{Autor: Ing. Eduard Jadron ml., Jilemnickeho 37/46, 036 01 Martin, SLOVENSKO}
{Program sluzi na zrychlenie numerickych operacii v pohyblivej ciarke, vyuzitim instrukcii matematickeho koprocesora 387}
{Z dovodu rychlosti bola prevazna cast unitu napisana v assembleri}
{Tento program je volne siritelny a modifikovatelny, ale nesmie sa vyuzivat komercne bez uhradenia registracneho poplatku !}
{Za pouzivanie tohoto programu je uzivatel povinny zaplatit symbolicky 2 USD ...}
{Pri uzivani programu bez uhradenia registracneho poplatku sa uzivatel dopusta poruseni autorskych prav, nehladiac na to,}
{ze sa dobrovolne vzdava novsich verzii programu.}
{V buducich dnoch program bude obohateny o niektore hyperbolicke funkcie sinh, cosh, tgh ....}

Unit NPU_387;

{N+,E-,G+,A+,F+,R-,S-,B-,D+}

interface

type xfloat      = extended;                            {Pozor, pri zmene typu premennych treba zmenit aj prislusne prefixy ..}

const
     Author      : string[15] = 'Eduard Jadron';
     Modify_Date : string[10] = '21.06.1998';

procedure F_Init;                                       {Inicializacia koprocesora 80387}
procedure Load_FCWR(var CWR:word);                      {Premennu CWR naplnim stavovym slovom koprocesora}
procedure Load_FSWR(var SWR:word);                      {Premennu SWR naplnim stavovym slovom koprocesora}
procedure Inc_Real(var X:xfloat;Y:xfloat);              {X:=X+Y}
procedure Dec_Real(var X:xfloat;Y:xfloat);              {X:=X-Y}
function FAdd(X,Y:xfloat):xfloat;                       {Z=X+Y}   {Goniometricke funkcie su v RAD !!!}
function FSub(X,Y:xfloat):xfloat;                       {Z=X-Y}
function FMul(X,Y:xfloat):xfloat;                       {Z=X*Y}
function Fdiv(X,Y:xfloat):xfloat;                       {Z=X/Y}
function FAbs(X:xfloat):xfloat;                         {Z=|X|}
function FSin(X:xfloat):xfloat;                         {Z=sin(X)}
function FCos(X:xfloat):xfloat;                         {Z=cos(X)}
function FTan(X:xfloat):xfloat;                         {Z=tan(X);  Z=(SIN(X)/COS(X))}
function FArcSin(X:xfloat):xfloat;                      {Z=arcsin(X)}
function FArcCos(X:xfloat):xfloat;                      {Z=arccos(X)}
function FArcTan(X:xfloat):xfloat;                      {Z=arctan(X)}
function FSinh(X:xfloat):xfloat;                        {Z=sinh(X)}
function FCosh(X:xfloat):xfloat;                        {Z=cosh(X)}
function FTgh(X:xfloat):xfloat;                         {Z=tgh(X)}
function FArcSinh(X:xfloat):xfloat;                     {Z=arcsinh(X)}
function FArcCosh(X:xfloat):xfloat;                     {Z=arccosh(X)}
function FArcTgh(X:xfloat):xfloat;                      {Z=arctgh(X)}
function FPI:xfloat;                                    {Z=PI}
function FSqrPI:xfloat;                                 {Z=PI^2}
function FSqrtPI:xfloat;                                {Z=SQRT(PI) zistim druhu odmocninu PI}
function FSqrt2(X:xfloat):xfloat;                       {Z=SQRT2(X) zistim druhu odmocninu X}
function FSqrt(X,Y:xfloat):xfloat;                      {Z=X^(1/Y) zistim Y odmocninu z X}
function FSqr_Int(X:xfloat;Y:integer):xfloat;           {Z=X^Y;    Y=[-32767 .. +32767]}
function FSqr(X,Y:xfloat):xfloat;                       {Z=X^Y;    Y=[-real .. +real]}
function Flog2_e:xfloat;                                {Z=LOG2(E)}
function Fln2:xfloat;                                   {Z=LN(2)}
function FLnX(X:xfloat):xfloat;                         {Z=LN(X)}
function FLogX(X:xfloat):xfloat;                        {Z=LOG(X)}
function FLog2_10:xfloat;                               {Z=LOG2(10)}
function FLog10_2:xfloat;                               {Z=LOG10(2)}
function FExp(X:xfloat):xfloat;                         {Z=e^X} {Rychly vypocet v ASM cca. 10000x rychlejsia ako FExp_2}
function FExp_2(X:xfloat):xfloat;                       {Z=e^X} {Vypocet, trochu pomaly pomocou rozvoja do radu ....}
function Mocnina(X,Y:xfloat):xfloat;                    {Z=X^Y}
function Fakt(X:word):xfloat;                           {Z=X!}
function FSum(X,Y:word):xfloat;                         {Z=SUM(1/i^2), i=[X .. Y]}
function FDegRad(X:xfloat):xfloat;                      {Prevedie spravne stupne na radiany}
function FRadDeg(X:xfloat):xfloat;                      {Prevedie spravne radiany na stupne}
function Det_2x2(A11,A12,A21,A22:xfloat):xfloat;                     {Z=DET(2x2)}
function Det_3x3(A11,A12,A13,A21,A22,A23,A31,A32,A33:xfloat):xfloat; {Z=DET(3x3)}
function BSF_286(Cislo:word):byte;                      {Funkcia vrati poradie prveho nenuloveho bitu v slove sprava}
function BSR_286(Cislo:word):byte;                      {Funkcia vrati poradie prveho nenuloveho bitu v slove zlava}

implementation

procedure F_Init; assembler;
asm
   FNINIT                         {Inicializacia 80387}
end;

procedure Load_FCWR(var CWR:word); assembler;
var Pomocna : word;
asm
   FNSTCW WORD PTR SS:[Pomocna]  {Do premennej ulozim obsah registra CWR koprocesoru}
   MOV AX,WORD PTR SS:[Pomocna]  {Presuniem do registra AX}
   LES DI,SS:[CWR]               {Do registra ES segment a do DI offset premennej CWR}
   CLD                           {Priznak smeru, inkrementalny}
   STOSW                         {Ulozim slovo na adresu ES:DI}
end;

procedure Load_FSWR(var SWR:word); assembler;
var Pomocna : word;
asm
   FNSTSW WORD PTR SS:[Pomocna]  {Do premennej ulozim obsah registra SWR koprocesoru}
   MOV AX,WORD PTR SS:[pomocna]  {Presuniem do registra AX}
   LES DI,SS:[SWR]               {Priznak smeru, inkrementalny}
   CLD                           {Priznak smeru, inkrementalny}
   STOSW                         {Ulozim slovo na adresu ES:DI}
end;

procedure Inc_Real(var X:xfloat;Y:xfloat);
begin
     asm
        PUSH ES                  {Register ES ukladam na zasobnik}
        PUSH DI                  {Register DI ukladam na zasobnik}
        PUSH SI                  {Register SI ukladam na zasobnik}
        LES SI,SS:[X]            {Do SI offset citanej premennej, ES obsahuje segment}
        FLD TBYTE PTR ES:[SI]    {Naplnim obsah ST(0) premennou z ES:SI}
        FLD TBYTE PTR SS:[Y]     {Naplnim obsah ST(0) premennou z SS:SI}
        FADDP ST(1),ST(0)        {Scitam ST(0)+ST(1) a dekrementujem vrchol zasobnika}
        LES DI,SS:[X]            {Do DI offset citanej premennej, ES obsahuje segment}
        FSTP TBYTE PTR ES:[DI]   {Vrchol registra ST(0) na ES:DI}
        POP SI                   {Obnovim register SI hodnotou zo zasobnika}
        POP DI                   {Obnovim register DI hodnotou zo zasobnika}
        POP ES                   {Obnovim register ES hodnotou zo zasobnika}
     end;
end;

procedure Dec_Real(var X:xfloat;Y:xfloat);
begin
     asm
        PUSH ES                  {Register ES ukladam na zasobnik}
        PUSH DI                  {Register DI ukladam na zasobnik}
        PUSH SI                  {Register SI ukladam na zasobnik}
        LES SI,SS:[X]            {Do SI offset citanej premennej, ES obsahuje segment}
        FLD TBYTE PTR ES:[SI]    {Naplnim obsah ST(0) premennou z ES:SI}
        FLD TBYTE PTR SS:[Y]     {Naplnim obsah ST(0) premennou z SS:SI}
        FSUBP ST(1),ST(0)        {Odcitam ST(1)-ST(0) a dekrementujem vrchol zasobnika}
        LES DI,SS:[X]            {Do DI offset citanej premennej, ES obsahuje segment}
        FSTP TBYTE PTR ES:[DI]   {Vrchol registra ST(0) na ES:DI}
        POP SI                   {Obnovim register SI hodnotou zo zasobnika}
        POP DI                   {Obnovim register DI hodnotou zo zasobnika}
        POP ES                   {Obnovim register ES hodnotou zo zasobnika}
     end;
end;

function FDegRad(X:xfloat):xfloat; assembler;
const Pomocna : word = 180;
asm
   FLD TBYTE PTR SS:[X]         {Na vrchol zasobnika ulozim premennu X}
   FILD WORD PTR DS:[Pomocna]   {Na vrchol zasobnika ulozim premennu Pomocna}
   FLDPI                        {Na vrchol zasobnika ulozim konstantu PI}
   FMULP ST(2),ST(0)            {Register ST(2) vynasobim ST(0) a vysledok ostava v ST(2) a incrementuje ukazovatel zasobnika}
   FDIVP ST(1),ST(0)            {Register ST(1) vydelim ST(0) a vysledok ostava v ST(1) a incrementuje ukazovatel zasobnika}
end;                            {Na zasobniku vraciam vysledok funkcie ....}

function FRadDeg(X:xfloat):xfloat; assembler;
const Pomocna : word = 180;
asm
   FILD WORD PTR DS:[Pomocna]   {Na vrchol zasobnika ulozim premennu Pomocna} {Zmena z SS: na DS:}
   FLDPI                        {Na vrchol zasobnika ulozim konstantu PI}
   FLD TBYTE PTR SS:[X]         {Na vrchol zasobnika ulozim premennu X}
   FMULP ST(2),ST(0)            {Register ST(2) vynasobim ST(0) a vysledok ostava v ST(2) a incrementuje ukazovatel zasobnika}
   FDIVP ST(1),ST(0)            {Register ST(1) vydelim ST(0) a vysledok ostava v ST(1)) a incrementuje ukazovatel zasobnika}
end;

function FAdd(X,Y:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Naplni vrchol zasobnika premennou z X}
   FLD TBYTE PTR SS:[Y]     {Naplni vrchol zasobnika premennou z Y}
   FADDP ST(1),ST(0)        {Register ST(1) scitam s reg. ST(0)}
end;

function FSub(X,Y:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Naplni vrchol zasobnika premennou z X}
   FLD TBYTE PTR SS:[Y]     {Naplni vrchol zasobnika premennou z Y}
   FSUBP ST(1),ST(0)        {Od registru ST(1) odcitam reg. ST(0)}
end;

function FMul(X,Y:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Naplni vrchol zasobnika premennou z X}
   FLD TBYTE PTR SS:[Y]     {Naplni vrchol zasobnika premennou z Y}
   FMULP ST(1),ST(0)        {Vynasobim vrchol zasobnika s reg. ST(1)}
end;

function FDiv(X,Y:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Naplni vrchol zasobnika premennou z X}
   FLD TBYTE PTR SS:[Y]     {Naplni vrchol zasobnika premennou z Y}
   FDIVP ST(1),ST(0)        {Register ST(1) vydelime registrom ST(0)}
end;

function FAbs(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Na vrchol zasobnika ulozime X}
   FABS                     {Na vrchol zasobniku ulozi absolutnu hodnotu vrchola zasobniku ST(0)}
end;

function FSin(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Na vrchol zasobnika ulozime X}
   DB 0D9h,0FEh             {Vrchol zasobnika naplnime Sinusom vrcholu zasobnika, FSIN instrukcia 386 !!!}
end;

function FCos(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]     {Na vrchol zasobnika ulozime X}
   DB 0D9h,0FFh;            {Vrchol zasobnika naplnime Cosinusom vrcholu zasobnika, FCOS instrukcia 386 !!!}
end;

function FPI:xfloat; assembler;
asm
   FLDPI             {Vrchol zasobnika naplnime konstantou PI}
end;

function FSqrPI:xfloat; assembler;
asm
   FLDPI            {Vrchol zasobnika naplnime konstantou PI}
   FLDPI            {Vrchol zasobnika naplnime konstantou PI}
   FMULP ST(1),ST(0){Register ST(1) vynasobime s ST(0) a dostaneme druhu mocninu PI}
end;

function FSqrtPI:xfloat; assembler;
asm
   FLDPI    {Na vrchol zasobnika ulozime hodnotu PI}
   FSQRT    {Vrchol zasobnika odmocnime a vyslednu hodnotu ulozime na vrchol zasobnika}
end;

function FSqrt2(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X] {Na vrchol zasobnika ulozime hodnotu X}
   FSQRT                {Vrchol zasobnika odmocnime a vyslednu hodnotu ulozime na vrchol zasobnika}
end;

function FSqrt(X,Y:xfloat):xfloat;
const Round_Down : word = $177F;
var  Stav_Slovo : word;
     Pomocna    : xfloat;
begin
     if X<=$00 then Halt($00); {X musi splnat podmienku X>=0 !!!}
     asm
        FLD1
        FLD TBYTE PTR SS:[Y]
        FDIV
        FLD TBYTE PTR SS:[X]
        FYL2X
        FSTCW WORD PTR SS:[Stav_Slovo]
        FLDCW WORD PTR DS:[Round_Down]  {Zmena DS: za SS:, sposobovala Floating Point Error 207, 24.07.1998.}
        FLD ST(0)
        FRNDINT
        FLDCW WORD PTR SS:[Stav_Slovo]
        FXCH ST(1)                      {Zamena FXCH za FXCH ST(1) dna 31.07.1997.}
        FSUB ST(0),ST(1)
        F2XM1
        FLD1
        FADDP ST(1),ST(0)
        FSCALE
        FSTP ST(1)
        FSTP TBYTE PTR SS:[Pomocna]     {Zmena 24.07.1998.}
     end;
     FSqrt:=Pomocna;
end;

function FCosh(X:xfloat):xfloat; assembler;
const Round_down : word   = $177F;
      One_half   : xfloat = 0.5;
var   Control_ww : word;
asm                             { ST(0)     ST(1)     ST(2) }
   FLD TBYTE PTR SS:[X]         {  x         -         -    }
   FLDL2E                       { log2(e)    x         -    }
   FMULP ST(1),ST(0)            { x.log2(e)  -         -    }
   FSTCW WORD PTR DS:[Control_ww]
   FLDCW WORD PTR DS:[Round_down]
   FLD ST(0)                    {  z         z          -   }
   FRNDINT                      { int(z)     z          -   }
   FLDCW WORD PTR DS:[Control_ww]
   FXCH                         {  z         i          -   }
   FSUB ST(0),ST(1)             {  f         i          -   }
   F2XM1                        { 2^f-1      i          -   }
   FLD1                         {  1        2^f-1       i   }
   FADDP ST(1),ST(0)            { 2^f        i          -   }
   FSCALE                       { 2^f.2^i    i          -   }
   FST ST(1)                    { e^x       e^x         -   }
   FLD1                         {  1         z          z   }
   FDIVRP ST(1),ST(0)           { 1/z        z          -   }
   FADDP ST(1),ST(0)            { z+1/z      -          -   }
   FLD TBYTE PTR DS:[One_half]  { 0.5       z+1/z       -   }   {Zmena SS: za DS:}
   FMULP ST(1),ST(0)            { ch(x)      -          -   }
end;

function FSinh(X:xfloat):xfloat; assembler;
const Round_down : word   = $177F;
      One_half   : xfloat = 0.5;
var   Control_ww : word;
asm                             { ST(0)     ST(1)     ST(2) }
   FLD TBYTE PTR SS:[X]         {  x         -         -    }
   FLDL2E                       { log2(e)    x         -    }
   FMULP ST(1),ST(0)            { x.log2(e)  -         -    }
   FSTCW WORD PTR DS:[Control_ww]
   FLDCW WORD PTR DS:[Round_down]
   FLD ST(0)                    {  y         y          -   }
   FRNDINT                      { int(y)     y          -   }
   FLDCW WORD PTR DS:[Control_ww]
   FXCH                         {  y         i          -   }
   FSUB ST(0),ST(1)             {  f         i          -   }
   F2XM1                        { 2^f-1      i          -   }
   FLD1                         {  1        2^f-1       i   }
   FADDP ST(1),ST(0)            { 2^f        i          -   }
   FSCALE                       { 2^f.2^i    i          -   }
   FST ST(1)                    { e^x       e^x         -   }
   FLD1                         {  1         z          z   }
   FDIVRP ST(1),ST(0)           { 1/z        z          -   }
   FSUBP ST(1),ST(0)            { z-1/z      -          -   }
   FLD TBYTE PTR DS:[One_half]  { 0.5      z-1/z)       -   }
   FMULP ST(1),ST(0)            { sh(x)      -          -   }
end;

function FTgh(X:xfloat):xfloat;
begin
     FTgh:=FSinh(X)/FCosh(X);
end;

function FArcCosh(X:xfloat):xfloat; assembler;
asm                                 {  ST(0)         ST(1)          ST(2)  }
   FLDLN2                           {  ln(2)          -              -     }
   FLD TBYTE PTR SS:[X]             {   x            ln(2)           -     }
   FLD ST(0)                        {   x             x             ln(2)  }
   FMUL ST(0),ST(0)                 {   x.x           x             ln(2)  }
   FLD1                             { x.x - 1         x             ln(2)  }
   FSQRT                            { sqrt(x2-1)      x             ln(2)  }
   FADDP ST(1),ST(0)                { x + z          ln(2)           -     }
   FYL2X                            { arg_ch(x)       -              -     }
end;

function FArcSinh(X:xfloat):xfloat; assembler;
asm                                 {  ST(0)         ST(1)          ST(2)  }
   FLDLN2                           {  ln(2)          -              -     }
   FLD TBYTE PTR SS:[X]             {   x            ln(2)           -     }
   FLD ST(0)                        {   x             x             ln(2)  }
   FMUL ST(0),ST(0)                 {   x.x           x             ln(2)  }
   FLD1                             {   1             x.x            x     }
   FADDP ST(1),ST(0)                { x.x + 1         x             ln(2)  }
   FSQRT                            { sqrt(x.x+1)     x             ln(2)  }
   FADDP ST(1),ST(0)                { x + z          ln(2)           -     }
   FYL2X                            { arg_sh(x)       -              -     }
end;

function FArcTgh(X:xfloat):xfloat; assembler;
asm                                 {  ST(0)         ST(1)          ST(2)  }
   FLDLN2                           {  ln(2)          -              -     }
   FLD TBYTE PTR SS:[X]             {   x            ln(2)           -     }
   FLD ST(0)                        {   x             x             ln(2)  }
   FLD1                             {   1             x              x     }
   FADDP ST(1),ST(0)                { 1 + x           x             ln(2)  }
   FXCH                             {   x            1 + x          ln(2)  }
   FLD1                             {   1             x             1 + x  }
   FSUBRP ST(1),ST(0)               { 1 - x          1 + x          ln(2)  }
   FDIVP ST(1),ST(0)                { 1+x/1-x        ln(2)           -     }
   FSQRT                            {                ln(2)           -     }
   FYL2X                            { ln(z)           -              -     }
end;

function FLog2_e:xfloat; assembler;
asm
   FLDL2E   {Na vrchol zasobniku ulozime hodnotu log2(e)}
end;

function FLn2:xfloat; assembler;
asm
   FLDLN2   {Na vrchol zasobniku ulozime hodnotu ln(2) }
end;

function FLog2_10:xfloat; assembler;
asm
   FLDL2T
end;

function FLog10_2:xfloat; assembler;
asm
   FLDLG2
end;

function FLnX(X:xfloat):xfloat; assembler;
asm
   FLDLN2                 {Na vrchol zasobniku ulozim ln(2)}
   FLD TBYTE PTR SS:[X]   {Na vrchol zasobniku ulozim X}
   FYL2X                  {Na vrchol zasob. ulozim log2(ST), decrement. ukazatel vrcholu zasob. a na novy}
end;                      {vrchol zasob. ulozim obsah stareho zasobniku vynasobeneho novou hodn. star. vrcholu zasob.}

function FLogX(X:xfloat):xfloat; assembler;
asm
   FLDLG2                 {Na vrchol zasobniku ulozim log10(2)}
   FLD TBYTE PTR SS:[X]   {Na vrchol zasobniku ulozim X}
   FYL2X                  {Na vrchol zasob. ulozim log2(ST), decrement. ukazatel vrcholu zasob. a na novy}
end;                      {vrchol zasob. ulozim obsah stareho zasobniku vynasobeneho novou hodn. star. vrcholu zasob.}

function FArcSin(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]        {Na vrchol zasobniku ulozim X}
   FLD ST(0)                   {Vrchol zasobnika naplnim ST(0)}
   FMUL ST(0),ST(0)            {Vynasobim medzi sebou reg. ST(0)*ST co je analogia druhej mocniny}
   FLD1                        {Na vrchol zasobniku ulozim 1}
   FSUBRP ST(1),ST(0)          {Od ST(1) odcitame vrchol zasobniku a vysledok ulozi na vrchol zasobniku}
   FSQRT                       {Odmocim vrchol zasobniku}
   FPATAN                      {Do reg. ST(1) ulozim arctan(ST(1)/ST) a incrementujem vrchol zasobnika}
end;

function FArcCos(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]        {Na vrchol zasobniku ulozim X}
   FLD ST(0)                   {Vrchol zasobnika naplnim ST(0)}
   FMUL ST(0),ST(0)            {Vynasobim medzi sebou reg. ST(0)*ST co je analogia druhej mocniny}
   FLD1                        {Na vrchol zasobniku ulozim 1}
   FSUBRP ST(1),ST(0)          {Od ST(1) odcitame vrchol zasobniku a vysledok ulozi na vrchol zasobniku}
   FSQRT                       {Odmocim vrchol zasobniku}
   FXCH ST(1)                  {Zamenim obsah vrcholu zasobnika s registrom ST(1), prevedena zmena z FXCH na FXCH ST(1)}
   FPATAN                      {Do reg. ST(1) ulozim arctan(ST(1)/ST) a incrementujem vrchol zasobnika}
end;

function FTan(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]        {Na vrchol zasobnika ulozime X}
   FPTAN                       {Na vrchol zasobnika ulozime tangens vrcholu zasobnika, dekrementujeme ukazovatel}
   FMULP ST(1),ST(0)           {a na vrchol zasobnika ulozime 1 a vynasobenim nic nestratime, ale incremetujeme}
end;                           {ukazovatel vrcholu zasobniku}

function FArcTan(X:xfloat):xfloat; assembler;
asm
   FLD TBYTE PTR SS:[X]         {Na vrchol zasobnika ulozime X}
   FPTAN                        {Na vrchol zasobnika ulozime tangens vrcholu zasobnika, dekrementujeme ukazovatel ...}
   FXCH ST(1)                   {Vrchol zasobnika ST(0) vymenime s registrom ST(1)}
   FDIVP ST(1),ST(0)            {Register ST(1) vydelime vrcholom zasobnika}
end;

function Fakt(X:word):xfloat; assembler;
var Pomocna : word;
asm
        FLD1                            {Na zasobnik ulozim 1}
        XOR AX,AX                       {Vynulujem register AX}
        INC AX                          {Incrementujem AX}
@CYKL:  MOV WORD PTR SS:[Pomocna],AX    {Do premennej pomocna ulozim reg. AX}
        FILD WORD PTR SS:[Pomocna]      {Na vrchol zasobnika ulozim slovo z premennej Pomocna}
        FMULP ST(1),ST(0)               {Register ST(1) vynasobim ST(0) a uncrementujem ukazovatel zasobnika}
        INC AX                          {Register AX zvysim o 1}
        CMP AX,WORD PTR SS:[X]          {Je dany faktorial ?}
        JNG @CYKL                       {Ak ano tak koniec}
end;

function FSqr(X,Y:xfloat):xfloat;
const Round_Down : word = $177F;
var   Pomocna    : xfloat;
      Stav_Slovo : word;
begin
     if X<$00 then Halt($00);           {X musi splnat podmienku X>=0 !!!}
     asm
        FLD TBYTE PTR SS:[Y]
        FLD TBYTE PTR SS:[X]
        FYL2X
        FSTCW WORD PTR SS:[Stav_Slovo]
        FLDCW WORD PTR DS:[Round_Down]
        FLD ST(0)
        FRNDINT
        FLDCW WORD PTR SS:[Stav_Slovo]
        FXCH ST(1)
        FSUB ST(0),ST(1)
        F2XM1
        FLD1
        FADDP ST(1),ST(0)
        FSCALE
        FSTP ST(1)
        FSTP TBYTE PTR SS:[Pomocna]
     end;
     FSqr:=Pomocna;
end;

function FSqr_Int(X:xfloat;Y:integer):xfloat; assembler;
var Pomocna : word;
    Priznak : integer;
asm
       MOV AX,WORD PTR SS:[Y]           {Do reg AX=^Y}
       MOV WORD PTR SS:[Priznak],AX     {Do premennej Priznak ^Y kvoli znamienku}
       XOR AX,AX                        {Vynulujem register AX}
       FILD WORD PTR SS:[Y]             {Naplnim vrchol zasobniku a dekrementuje ukazatel vrcholu zasobniku}
       FABS                             {Vrchol zasobnik naplnim absolutnou hodnotou vrchola zasobnika}
       FISTP WORD PTR SS:[Y]            {Ulozim obsah vrcholu zasobnika do premennej Y}
       CMP WORD PTR SS:[Y],0000H        {Porovnam premennu Y s 0000H}
       JE @END1                         {Ak Y=0000H tak skocim na @END1}
       INC AX                           {Ak Y<>0000H tak incrementujem AX}
       FLD TBYTE PTR SS:[X]             {Naplnim vrchol zasobnika premennou X typu xfloat}
       CMP WORD PTR SS:[Y],0001H        {Porovnavam premennu Y s 0001H}
       JE @END0                         {Ak Y=0001H tak skocim na @END0}
@CYKL: MOV WORD PTR SS:[Pomocna],AX     {Do premennej Pomocna ulozim register AX}
       FLD TBYTE PTR SS:[X]             {Na vrchol zasobnika ulozim premennu X}
       FMULP ST(1),ST(0)                {Vynasobim register ST(1) s registrom ST(0) a vysledok dam na vrchol zasobnika}
       INC AX                           {Incrementujem AX, co je pocitadlo prechodu}
       CMP AX,WORD PTR SS:[Y]           {Porovnavam register AX a Premennu Y}
       JNGE @CYKL                       {Skok ak nie je vacsie, alebo nie je rovne}
       JMP NEAR PTR [@END0]             {Nepodmieneny skok na @END0}               {*******************}
@END1: FLD1                             {Naplnim na vrchol zasobnika 1, X^0=1}
@END0: CMP WORD PTR SS:[Priznak],0000H  {Porovnaj Premennu Priznak s 00000H}
       JNS @ZAP0                        {Skoc ak nie je Priznak zaporny na @ZAP0}
       FLD1                             {Na vrchol zasobnika uloz 1}
       FXCH ST(1)                       {Vymenim vrchol zasobnika z registrom ST(1) navzajom***}
       FDIVP ST(1),ST(0)                {Register ST(1) vydelim ST(0) a ulozim vysledok na vrchol zasobnika}
@ZAP0:                                  {a incerementujem ukazovatel vrcholu zasobnika}
end;

function BSF_286(Cislo:word):byte;
var Pomocna : byte;
begin
     asm
        cmp word ptr ss:[Cislo],0000h   {Porovnam, lebo vysledok nesmie byt nulovy}
        jz @Kon                         {Ak je, tak skocim na koniec funkcie}
        mov ch,00h                      {CH register je pocitadlo prechodov v slucke}
        mov cl,01h                      {CL posuvam o 1 bit cez Carry}
        clc                             {Pre istotu nulujem Carry bit}
@Cykl:  rcr word ptr ss:[Cislo],cl      {Prevediem rotaciu}
        inc ch                          {Obsah CH zvysim o 1}
        jnc @Cykl                       {Ak je carry nastaveny, potom som nasiel prvy nenulovy bit sprava}
        dec ch                          {Korekcia na D0..D7}
@Kon:   mov byte ptr ss:[Pomocna],ch    {Vraciam vysledok prevedenej funkcie}
     end;
     BSF_286:=Pomocna;
end;

function BSR_286(Cislo:word):byte;
var Pomocna : byte;
begin
     asm
        cmp word ptr ss:[Cislo],0000h   {Porovnam, lebo vysledok nesmie byt nulovy}
        jz @Kon                         {Ak je, tak skocim na koniec funkcie}
        mov ch,00h                      {CH register je pocitadlo prechodov v slucke}
        mov cl,01h                      {CL posuvam o 1 bit cez Carry}
        clc                             {Pre istotu nulujem Carry bit}
@Cykl:  rcl word ptr ss:[Cislo],cl      {Prevediem rotaciu}
        inc ch                          {Obsah CH zvysim o 1}
        jnc @Cykl                       {Ak je carry nastaveny, potom som nasiel prvy nenulovy bit zlava}
        dec ch                          {Korekcia na D0..D7}
@Kon:   mov byte ptr ss:[Pomocna],ch    {Vraciam vysledok prevedenej funkcie}
     end;
     BSR_286:=Pomocna;
end;

function FExp(X:xfloat):xfloat; assembler;
const Round_Down : word   = $177F;
var   Control_ww : word;
asm                             { ST(0)     ST(1)     ST(2) }
   FLD TBYTE PTR SS:[X]         {  x         -         -    }
   FLDL2E                       { log2(e)    x         -    }
   FMULP ST(1),ST(0)            { x.log2(e)  -         -    }
   FSTCW WORD PTR DS:[Control_ww]
   FLDCW WORD PTR DS:[Round_Down]
   FLD ST(0)                    {  y         y          -   }
   FRNDINT                      { int(y)     y          -   }
   FLDCW WORD PTR DS:[Control_ww]
   FXCH                         {  y         i          -   }
   FSUB ST(0),ST(1)                {  f         i          -   }
   F2XM1                        { 2^f-1      i          -   }
   FLD1                         {  1        2^f-1       i   }
   FADDP ST(1),ST(0)            { 2^f        i          -   }
   FSCALE                       { 2^f.2^i    i          -   }
   FSTP ST(1)                   {V ST(1) ostane v zasobniku po vypocte hodnota, preto je oznacim ako nepouzitu}
end;

function FExp_2(X:xfloat):xfloat;
var   Pomocna   : xfloat;
      Y         : byte;
const Z         : byte = 30;
begin
     Pomocna:=$00;
     for Y:=$00 to Z do
         begin                                              {Rozviniem do radu ...}
              Pomocna:=Pomocna+(FSqr(FAbs(X),Y))/(Fakt(Y)); {Z=(|X|^Y0)/Y0!+(|X|^Y1)/Y1! ....}
         end;
     if X<$00 then
                  begin
                       FExp_2:=$01/(Pomocna);
                  end
                     else
                  begin
                       FExp_2:=Pomocna;
                  end;
end;

function Mocnina(X,Y:xfloat):xfloat;
begin
     Mocnina:=Exp(Y*Ln(X));             {Vypocita lubovolnu mocninu cisla}
end;

function FSum(X,Y:word):xfloat;
var Pomocna : xfloat;
    i       : word;
begin
     Pomocna:=$00;
     for i:=Y downto X do
         begin
              Pomocna:=Pomocna+(1/FSqr(i,2));
         end;
              FSum:=Pomocna;
end;

function Det_2x2(A11,A12,A21,A22:xfloat):xfloat;
begin
     Det_2x2:=(A11*A22)-(A12*A21);      {Vypocitam determinant matice 2x2}
end;

function Det_3x3(A11,A12,A13,A21,A22,A23,A31,A32,A33:xfloat):xfloat;    {Vypocitam determinant matice 3x3}
begin
     Det_3x3:=(A11*A22*A33)+(A12*A23*A31)+(A13*A21*A32)-(A13*A22*A31)-(A12*A21*A33)-(A11*A23*A32);
end;

end. {Koniec NPU_387}